| http://www.sim.no/ http://www.coin3d.org/

- Main Page
- Related Pages
- Modules
- Classes
- Files

- Class List
- Class Index
- Class Hierarchy
- Class Members

Public Member Functions | Static Public Member Functions | Public Attributes | Protected Member Functions | Static Protected Member Functions | List of all members
SoNurbsProfile Class Reference
Node Classes

The SoNurbsProfile class is a node for specifying smooth profile curves.Use nodes of this type if you want to set up profiles that are smooth curves. More...

`#include <Inventor/nodes/SoNurbsProfile.h>`

Inheritance diagram for SoNurbsProfile:

## Public Member Functions

virtual SoType | getTypeId (void) const
| SoNurbsProfile (void)
virtual void | getTrimCurve (SoState *state, int32_t &numpoints, float *&points, int &floatspervec, int32_t &numknots, float *&knotvector)
virtual void | getVertices (SoState *state, int32_t &numvertices, SbVec2f *&vertices)
Public Member Functions inherited from SoProfile
virtual void | doAction (SoAction *action)
virtual void | callback (SoCallbackAction *action)
virtual void | GLRender (SoGLRenderAction *action)
virtual void | getBoundingBox (SoGetBoundingBoxAction *action)
virtual void | pick (SoPickAction *action)
virtual void | getPrimitiveCount (SoGetPrimitiveCountAction *action)
Public Member Functions inherited from SoNode
void | setOverride (const SbBool state)
SbBool | isOverride (void) const
void | setNodeType (const NodeType type)
NodeType | getNodeType (void) const
virtual SoNode * | copy (SbBool copyconnections=FALSE) const
virtual SbBool | affectsState (void) const
virtual void | GLRenderBelowPath (SoGLRenderAction *action)
virtual void | GLRenderInPath (SoGLRenderAction *action)
virtual void | GLRenderOffPath (SoGLRenderAction *action)
virtual void | getMatrix (SoGetMatrixAction *action)
virtual void | handleEvent (SoHandleEventAction *action)
virtual void | rayPick (SoRayPickAction *action)
virtual void | search (SoSearchAction *action)
virtual void | write (SoWriteAction *action)
virtual void | audioRender (SoAudioRenderAction *action)
virtual void | grabEventsSetup (void)
virtual void | grabEventsCleanup (void)
virtual void | startNotify (void)
virtual void | notify (SoNotList *l)
uint32_t | getNodeId (void) const
virtual SoChildList * | getChildren (void) const
virtual void | writeInstance (SoOutput *out)
virtual SoNode * | addToCopyDict (void) const
virtual void | copyContents (const SoFieldContainer *from, SbBool copyconnections)
virtual SoFieldContainer * | copyThroughConnection (void) const
Public Member Functions inherited from SoFieldContainer
void | setToDefaults (void)
SbBool | hasDefaultValues (void) const
SbBool | fieldsAreEqual (const SoFieldContainer *container) const
void | copyFieldValues (const SoFieldContainer *container, SbBool copyconnections=FALSE)
SbBool | set (const char *const fielddata)
void | get (SbString &fielddata)
virtual int | getFields (SoFieldList &l) const
virtual int | getAllFields (SoFieldList &l) const
virtual SoField * | getField (const SbName &name) const
virtual SoField * | getEventIn (const SbName &name) const
virtual SoField * | getEventOut (const SbName &name) const
SbBool | getFieldName (const SoField *const field, SbName &name) const
SbBool | enableNotify (const SbBool flag)
SbBool | isNotifyEnabled (void) const
SbBool | set (const char *fielddata, SoInput *input)
void | get (SbString &fielddata, SoOutput *out)
virtual SbBool | validateNewFieldValue (SoField *field, void *newval)
virtual void | addWriteReference (SoOutput *out, SbBool isfromfield=FALSE)
SbBool | getIsBuiltIn (void) const
virtual void | getFieldsMemorySize (size_t &managed, size_t &unmanaged) const
void | setUserData (void *userdata) const
void * | getUserData (void) const
Public Member Functions inherited from SoBase
void | ref (void) const
void | unref (void) const
void | unrefNoDelete (void) const
int32_t | getRefCount (void) const
void | touch (void)
SbBool | isOfType (SoType type) const
virtual SbName | getName (void) const
virtual void | setName (const SbName &newname)
void | addAuditor (void *const auditor, const SoNotRec::Type type)
void | removeAuditor (void *const auditor, const SoNotRec::Type type)
const SoAuditorList & | getAuditors (void) const
SbBool | shouldWrite (void)
void | assertAlive (void) const

## Static Public Member Functions

static SoType | getClassTypeId (void)
static void | initClass (void)
Static Public Member Functions inherited from SoProfile
static SoType | getClassTypeId (void)
static void | initClass (void)
Static Public Member Functions inherited from SoNode
static uint32_t | getCompatibilityTypes (const SoType &nodetype)
static SoType | getClassTypeId (void)
static SoNode * | getByName (const SbName &name)
static int | getByName (const SbName &name, SoNodeList &l)
static void | initClass (void)
static void | initClasses (void)
static uint32_t | getNextNodeId (void)
static int | getActionMethodIndex (const SoType type)
static void | getBoundingBoxS (SoAction *action, SoNode *node)
static void | GLRenderS (SoAction *action, SoNode *node)
static void | callbackS (SoAction *action, SoNode *node)
static void | getMatrixS (SoAction *action, SoNode *node)
static void | handleEventS (SoAction *action, SoNode *node)
static void | pickS (SoAction *action, SoNode *node)
static void | rayPickS (SoAction *action, SoNode *node)
static void | searchS (SoAction *action, SoNode *node)
static void | writeS (SoAction *action, SoNode *node)
static void | audioRenderS (SoAction *action, SoNode *node)
static void | getPrimitiveCountS (SoAction *action, SoNode *node)
Static Public Member Functions inherited from SoFieldContainer
static void | initClass (void)
static SoType | getClassTypeId (void)
static void | cleanupClass (void)
static void | initCopyDict (void)
static void | addCopy (const SoFieldContainer *orig, const SoFieldContainer *copy)
static SoFieldContainer * | checkCopy (const SoFieldContainer *orig)
static SoFieldContainer * | findCopy (const SoFieldContainer *orig, const SbBool copyconnections)
static void | copyDone (void)
Static Public Member Functions inherited from SoBase
static void | initClass (void)
static SoType | getClassTypeId (void)
static void | addName (SoBase *const base, const char *const name)
static void | removeName (SoBase *const base, const char *const name)
static void | incrementCurrentWriteCounter (void)
static void | decrementCurrentWriteCounter (void)
static SoBase * | getNamedBase (const SbName &name, SoType type)
static int | getNamedBases (const SbName &name, SoBaseList &baselist, SoType type)
static SbBool | read (SoInput *input, SoBase *&base, SoType expectedtype)
static void | setInstancePrefix (const SbString &c)
static void | setTraceRefs (SbBool trace)
static SbBool | getTraceRefs (void)
static SbBool | connectRoute (SoInput *input, const SbName &fromnodename, const SbName &fromfieldname, const SbName &tonodename, const SbName &tofieldname)
static SbBool | readRoute (SoInput *input)

## Public Attributes

SoMFFloat | knotVector
Public Attributes inherited from SoProfile
SoMFInt32 | index
SoSFEnum | linkage

## Protected Member Functions

virtual const SoFieldData * | getFieldData (void) const
virtual | ~SoNurbsProfile ()
Protected Member Functions inherited from SoProfile
| SoProfile (void)
virtual | ~SoProfile ()
Protected Member Functions inherited from SoNode
| SoNode (void)
virtual | ~SoNode ()
virtual SbBool | readInstance (SoInput *in, unsigned short flags)
Protected Member Functions inherited from SoFieldContainer
| SoFieldContainer (void)
virtual | ~SoFieldContainer ()
Protected Member Functions inherited from SoBase
| SoBase (void)
virtual | ~SoBase ()
virtual void | destroy (void)
SbBool | hasMultipleWriteRefs (void) const
SbBool | writeHeader (SoOutput *out, SbBool isgroup, SbBool isengine) const
void | writeFooter (SoOutput *out) const
virtual const char * | getFileFormatName (void) const

## Static Protected Member Functions

static const SoFieldData ** | getFieldDataPtr (void)
Static Protected Member Functions inherited from SoProfile
static const SoFieldData ** | getFieldDataPtr (void)
Static Protected Member Functions inherited from SoNode
static const SoFieldData ** | getFieldDataPtr (void)
static void | setNextActionMethodIndex (int index)
static int | getNextActionMethodIndex (void)
static void | incNextActionMethodIndex (void)
static void | setCompatibilityTypes (const SoType &nodetype, const uint32_t bitmask)

## Additional Inherited Members

Public Types inherited from SoProfile
enum | Profile { START_FIRST = SoProfileElement::START_FIRST, START_NEW = SoProfileElement::START_NEW, ADD_TO_CURRENT = SoProfileElement::ADD_TO_CURRENT }
Protected Types inherited from SoBase
enum | BaseFlags { IS_ENGINE = 0x01, IS_GROUP = 0x02 }
Protected Attributes inherited from SoNode
uint32_t | uniqueId
Static Protected Attributes inherited from SoNode
static uint32_t | nextUniqueId = 1
static int | nextActionMethodIndex = 0

## Detailed Description

The SoNurbsProfile class is a node for specifying smooth profile curves.

Use nodes of this type if you want to set up profiles that are smooth curves.

A typical usage case for SoNurbsProfile is to specify NURBS trimming curves. For example:

#Inventor V2.1 ascii
ShapeHints {
vertexOrdering COUNTERCLOCKWISE
}
Coordinate3 {
point [
-3 -3 -3, -3 -1 -3, -3 1 -3, -3 3 -3,
-1 -3 -3, -1 -1 3, -1 1 3, -1 3 -3,
1 -3 -3, 1 -1 3, 1 1 3, 1 3 -3,
3 -3 -3, 3 -1 -3, 3 1 -3, 3 3 -3
]
}
ProfileCoordinate2 {
point [ 0.0 0.0 ,
0.75 0.0,
0.75 0.75 ,
0.25 0.75 ,
0.0 0.0 ]
}
NurbsProfile {
index [ 0 , 1 , 2 , 3, 4 ]
linkage START_NEW
knotVector [ 0, 0, 0, 0, 0.5, 1, 1, 1, 1 ]
}
NurbsSurface {
numUControlPoints 4
numVControlPoints 4
uKnotVector [ 0.0, 0.0, 0.0, 0.0, 1.0, 1.0, 1.0, 1.0 ]
vKnotVector [ 0.0, 0.0, 0.0, 0.0, 1.0, 1.0, 1.0, 1.0 ]
}

Note that the coordinates of the NurbsProfile live in the parametric space of the trimmed SoNurbsSurface, and that the same complexity setting (which is calculated based on the dimensions of the bounding box of the nurbs surface) is used to determine the sampling tolerance both for the SoNurbsSurface and the SoNurbsProfile.

This means that if you want to change the tessellation of the trimming curve itself (i.e. increase or decrease the resolution of the boundaries of the "cut-out"), you should not change the SoComplexity setting but rather adapt the parametric scale in relation to the trimmed surface.

As an example, to increase the resolution of the curve in the above example, replace...

ProfileCoordinate2 {
point [ 0.0 0.0, 0.75 0.0, 0.75 0.75, 0.25 0.75, 0.0 0.0 ]
}

.. with...

ProfileCoordinate2 {
point [ 0.0 0.0, 7.5 0.0, 7.5 7.5, 2.5 7.5, 0.0 0.0 ]
}

and change the uKnotVector and vKnotVector of the NurbsSurface to be

uKnotVector [ 0.0, 0.0, 0.0, 0.0, 10, 10, 10, 10 ]
vKnotVector [ 0.0, 0.0, 0.0, 0.0, 10, 10, 10, 10 ]

However, keep in mind that increasing the accuracy of the trimming curve results in a much more complex tesselation of the trimmed surface. As a general rule of thumb, the extent of the trimming curve coordinates should never be greater than its "real" extents in relation to the trimmed surface, and often can be much lower.

If you find the above confusing, you probably do not want to use NURBS without reading up on the general concepts first. An explanation of NURBS is beyond the scope of the Coin documentation; for detailed information, refer to the specialized literature on the topic (for example "An Introduction to NURBS: With Historical Perspective" by David F. Rogers). A basic overview of curve and surface rendering using NURBS can also be found in chapter 8 of "The Inventor Mentor".

FILE FORMAT/DEFAULTS:

NurbsProfile {
index 0
linkage START_FIRST
knotVector 0
}

## Constructor & Destructor Documentation

SoNurbsProfile::SoNurbsProfile | ( | void | ) |  |

Constructor.

SoNurbsProfile::~SoNurbsProfile | ( | ) |  |

protectedvirtual

Destructor.

## Member Function Documentation

SoType SoNurbsProfile::getTypeId | ( | void | ) |  | const

virtual

Returns the type identification of an object derived from a class inheriting SoBase. This is used for run-time type checking and "downward" casting.

Usage example:

void foo(SoNode * node)
{
if (node->getTypeId() == SoFile::getClassTypeId()) {
SoFile * filenode = (SoFile *)node; // safe downward cast, knows the type
}
}

For application programmers wanting to extend the library with new nodes, engines, nodekits, draggers or others: this method needs to be overridden in all subclasses. This is typically done as part of setting up the full type system for extension classes, which is usually accomplished by using the pre-defined macros available through for instance Inventor/nodes/SoSubNode.h (SO_NODE_INIT_CLASS and SO_NODE_CONSTRUCTOR for node classes), Inventor/engines/SoSubEngine.h (for engine classes) and so on.

For more information on writing Coin extensions, see the class documentation of the toplevel superclasses for the various class groups.

Reimplemented from SoProfile.

const SoFieldData * SoNurbsProfile::getFieldData | ( | void | ) |  | const

protectedvirtual

Returns a pointer to the class-wide field data storage object for this instance. If no fields are present, returns `NULL`.

Reimplemented from SoProfile.

void SoNurbsProfile::getTrimCurve | ( | SoState * | state,
|  | int32_t & | numpoints,
|  | float *& | points,
|  | int & | floatspervec,
|  | int32_t & | numknots,
|  | float *& | knotvector
| ) |  |

virtual

Return points and knotvector of the state.

Implements SoProfile.

void SoNurbsProfile::getVertices | ( | SoState * | state,
|  | int32_t & | numvertices,
|  | SbVec2f *& | vertices
| ) |  |

virtual

Return vertex set of state.

Implements SoProfile.

## Member Data Documentation

SoMFFloat SoNurbsProfile::knotVector

Knot values for the nurbs curve.

The documentation for this class was generated from the following files:

- SoNurbsProfile.h
- SoNurbsProfile.cpp

Copyright © 1998-2010 by Kongsberg Oil & Gas Technologies. All rights reserved.